# Wasm3
🚀 The fastest WebAssembly interpreter

[![WAPM](https://wapm.io/package/vshymanskyy/wasm3/badge.svg)](https://wapm.io/package/vshymanskyy/wasm3) 
[![GitHub issues](https://img.shields.io/github/issues-raw/wasm3/wasm3?style=flat-square&label=issues&color=success)](https://github.com/wasm3/wasm3/issues) 
[![Tests status](https://img.shields.io/github/workflow/status/wasm3/wasm3/tests/master?style=flat-square&logo=github&label=tests)](https://github.com/wasm3/wasm3/actions) 
[![GitHub license](https://img.shields.io/badge/license-MIT-blue?style=flat-square)](https://github.com/wasm3/wasm3)


Main repository: [**Wasm3 project**](https://github.com/wasm3/wasm3)  
This library can be used with 
[`Arduino`](https://www.arduinolibraries.info/libraries/wasm3), 
[`PlatformIO`](https://platformio.org/lib/show/6973/Wasm3) and 
[`Particle`](https://build.particle.io/libs/Wasm3/latest/tab/example/Wasm_Blink.ino).

## Supported devices

Wasm3 requires at least **~64Kb** Flash and **~10Kb** RAM even for minimal functionality.

The library was verified to work with:  
`ESP32`, `ESP8266`, `Arduino MKR`, `Particle`,  
`RTL8711`, `ST Nucleo WB55RG`, `BluePill`,  
`Nordic nRF5`, `Teensy`, ... [see full list](https://github.com/wasm3/wasm3/blob/master/docs/Hardware.md)

## Disclaimer

Please also note that Arduino API here is just for an example. We do not encourage this way of programming, and we have to come up with a better API (i.e. **Event-Driven**, **Resource-Oriented** or similar).

### License
This project is released under The MIT License (MIT)
